//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                                    e-MACD_MTF.mq4 |
//|                                       Copyright  2013, Igor Stepovoi aka TarasBY |
//|                                                                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-12, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
#define       BULL       0
#define       BEAR       1
#define       STOP      -1
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                   *****                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern string com               = " ";
extern int    Magic                = 2013;
extern double Lots                 = 0.01;
extern int    StopLoss             = 20;
extern int    TakeProfit           = 30;
extern int    Slippage             = 1;
extern int    SleepOnBarAfterTrade = 1;
extern int    SignalSendOnBar      = 1;      //    ( )    
extern string Exp_Comment          = "MACD";
extern string com1              = " MACD  m1";
extern int    FastEMA1m            = 12;
extern int    SlowEMA1m            = 26;
extern int    SignalSMA1m          = 9;
extern string com2              = " MACD  m5";
extern int    FastEMA5m            = 12;
extern int    SlowEMA5m            = 26;
extern int    SignalSMA5m          = 9;
extern string com3              = " MACD  m15";
extern int    FastEMA15m           = 12;
extern int    SlowEMA15m           = 26;
extern int    SignalSMA15m         = 9;
extern string com4              = " MACD  m30";
extern int    FastEMA30m           = 12;
extern int    SlowEMA30m           = 26;
extern int    SignalSMA30m         = 9;
extern string com5              = " MACD  1";
extern int    FastEMAh1            = 12;
extern int    SlowEMAh1            = 26;
extern int    SignalSMAh1          = 9;
extern string com6              = " MACD  h4";
extern int    FastEMAh4            = 12;
extern int    SlowEMAh4            = 26;
extern int    SignalSMAh4          = 9;
//IIIIIIIIIIIIIIIIIII======  ======IIIIIIIIIIIIIIIIIIIIII+
double        gd_SL, gd_TP;
int           gia_FastEMA[6], gia_SlowEMA[6], gia_SignalSMA[6],
              gia_Periods[] = {PERIOD_M1,PERIOD_M5,PERIOD_M15,PERIOD_M30,PERIOD_H1, PERIOD_H4};
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom expert initialization function                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int init()
{
//----
    if (Digits % 2 == 1) //  5  4 
    {
        TakeProfit *= 10;
        StopLoss *= 10;
        Slippage *= 10;
    }
	gd_SL = StopLoss * Point;
	gd_TP = TakeProfit * Point;
	gia_FastEMA[0] = FastEMA1m;
	gia_SlowEMA[0] = SlowEMA1m;
	gia_SignalSMA[0] = SignalSMA1m;
	gia_FastEMA[1] = FastEMA5m;
	gia_SlowEMA[1] = SlowEMA5m;
	gia_SignalSMA[1] = SignalSMA5m;
	gia_FastEMA[2] = FastEMA15m;
	gia_SlowEMA[2] = SlowEMA15m;
	gia_SignalSMA[2] = SignalSMA15m;
	gia_FastEMA[3] = FastEMA30m;
	gia_SlowEMA[3] = SlowEMA30m;
	gia_SignalSMA[3] = SignalSMA30m;
	gia_FastEMA[4] = FastEMAh1;
	gia_SlowEMA[4] = SlowEMAh1;
	gia_SignalSMA[4] = SignalSMAh1;
	gia_FastEMA[5] = FastEMAh4;
	gia_SlowEMA[5] = SlowEMAh4;
	gia_SignalSMA[5] = SignalSMAh4;
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom expert deinitialization function                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int deinit()
{
//----
    return (0);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom expert iteration function                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void start()
{
    int li_MyOrd = 0; //  
//----
    for (int li_pos = 0; li_pos < OrdersTotal(); li_pos++)
    {
        if (!OrderSelect (li_pos, SELECT_BY_POS)) continue;
        if (OrderSymbol () != Symbol ()) continue;
		if (OrderMagicNumber() != Magic) continue;
        li_MyOrd++;
    }
	//----     - 
    if (li_MyOrd > 0) return;
	int li_Bars = BarsAfterCloseLastPos (Magic);
	//----     li_Bars   TF
	if (li_Bars >= 0) if (li_Bars < SleepOnBarAfterTrade) return;
	int li_Signal = fGet_SignalPolyMACD (SignalSendOnBar);
	if (li_Signal == STOP) return;
    //----
	int    li_cmd = 1, li_Ticket;
	double ld_Price = 0.;
	color  lca_color[] = {Green,Red};
    //----
    if (li_Signal == BEAR) {li_cmd = -1; ld_Price = Bid;} else ld_Price = Ask;
    //----    
    li_Ticket = OrderSend (Symbol(), li_Signal, Lots, NormalizeDouble (ld_Price, Digits), Slippage, 0, 0, Exp_Comment, Magic, 0, lca_color[li_Signal]);
	if (li_Ticket > 0)
    {
        //----        
        if (OrderSelect (li_Ticket, SELECT_BY_TICKET))
        {
	        double ld_SL = NormalizeDouble (ld_Price - li_cmd * gd_SL, Digits),
                   ld_TP = NormalizeDouble (ld_Price + li_cmd * gd_TP, Digits);
			//----         
            OrderModify (li_Ticket, OrderOpenPrice(), ld_SL, ld_TP, 0);
        }
    }
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|           MACD   TF                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_SignalPolyMACD (int fi_Bar = 0)
{
	double lda_MACD[2];
	int    li_IND, lia_Signal[] = {0,0};
//----
    for (int li_PRD = 0; li_PRD < 6; li_PRD++)
	{
	    //----        TF
		for (li_IND = 0; li_IND < 2; li_IND++)
		{lda_MACD[li_IND] = iMACD (Symbol(), gia_Periods[li_PRD], gia_FastEMA[li_PRD], gia_SlowEMA[li_PRD], gia_SignalSMA[li_PRD], PRICE_CLOSE, li_IND, fi_Bar);}
		//----        
		if (NormalizeDouble (lda_MACD[0] - lda_MACD[1], Digits) > 0.) lia_Signal[0]++;
		else if (NormalizeDouble (lda_MACD[0] - lda_MACD[1], Digits) < 0.) lia_Signal[1]++;
		//----     TF    - 
		if (lia_Signal[0] < li_PRD + 1) if (lia_Signal[1] < li_PRD + 1) return (-1);
	}
	int li_Signal = STOP;
	for (li_IND = 0; li_IND < 2; li_IND++)
	{if (lia_Signal[li_IND] == 6) {li_Signal = li_IND; break;}}
//----
    return (li_Signal);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          ,           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int BarsAfterCloseLastPos (int fi_MG, int fi_Type = -1)
{
    datetime ldt_Time = 0;
    int      li_Total = OrdersHistoryTotal();
//----
    if (li_Total == 0) return (-1);
	for (int li_pos = 0; li_pos < li_Total; li_pos++)
    {
        if (!OrderSelect (li_pos, SELECT_BY_POS, MODE_HISTORY)) continue;
        if (OrderSymbol() != Symbol()) continue;
        if (fi_Type >= 0) if (OrderType() != fi_Type) continue;
        if (OrderMagicNumber() != fi_MG) continue;
        if (ldt_Time >= OrderCloseTime()) continue;
        ldt_Time = OrderCloseTime();
    }
    //----   -   
    if (ldt_Time == 0) return (-1);
//----
    return (iBarShift (NULL, 0, ldt_Time));
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
